Package org.pentaho.reporting.libraries.resourceloader

# Interface ResourceManagerBackend

All Known Implementing Classes:
  `DefaultResourceManagerBackend`

public interface ResourceManagerBackend
Todo: Document Me

Author:
  Thomas Morgner

## Method Summary

Modifier and Type
Method
Description
`Resource`
`create(ResourceManager frontEnd, ResourceData key, ResourceKey context, Class[] target)`
`ResourceKey`
`createKey(Object data, Map parameters)`
`ResourceKey`
`deriveKey(ResourceKey parent, String path, Map parameters)`
`ResourceKey`
`deserialize(ResourceKey bundleKey, String serializedKey)`
`boolean`
`isResourceUnchanged(ResourceManager resourceManager, Resource resource)`
`ResourceData`
`loadRawData(ResourceManager frontEnd, ResourceKey key)`
`ResourceBundleData`
`loadResourceBundle(ResourceManager frontEnd, ResourceKey key)`
`void`
`registerBundleLoader(ResourceBundleLoader loader)`
`void`
`registerDefaultFactories()`
`void`
`registerDefaultLoaders()`
`void`
`registerFactory(ResourceFactory factory)`
`void`
`registerLoader(ResourceLoader loader)`
`String`
`serialize(ResourceKey bundleKey, ResourceKey key)`
`URL`
`toURL(ResourceKey key)`

## Method Details

### createKey

ResourceKey createKey(Object data, Map parameters) throws ResourceKeyCreationException

Throws:
  `ResourceKeyCreationException`

### deriveKey

ResourceKey deriveKey(ResourceKey parent, String path, Map parameters) throws ResourceKeyCreationException

Throws:
  `ResourceKeyCreationException`

### toURL

URL toURL(ResourceKey key)

### create

Resource create(ResourceManager frontEnd, ResourceData key, ResourceKey context, Class[] target) throws ResourceLoadingException, ResourceCreationException

Throws:
  `ResourceLoadingException`
  `ResourceCreationException`

### loadResourceBundle

ResourceBundleData loadResourceBundle(ResourceManager frontEnd, ResourceKey key) throws ResourceLoadingException

Throws:
  `ResourceLoadingException`

### registerDefaultFactories

void registerDefaultFactories()

### registerDefaultLoaders

void registerDefaultLoaders()

### registerBundleLoader

void registerBundleLoader(ResourceBundleLoader loader)

### registerLoader

void registerLoader(ResourceLoader loader)

### registerFactory

void registerFactory(ResourceFactory factory)

### loadRawData

ResourceData loadRawData(ResourceManager frontEnd, ResourceKey key) throws ResourceLoadingException, UnrecognizedLoaderException

Throws:
  `ResourceLoadingException`
  `UnrecognizedLoaderException`

### isResourceUnchanged

boolean isResourceUnchanged(ResourceManager resourceManager, Resource resource) throws ResourceLoadingException

Throws:
  `ResourceLoadingException`

### serialize

String serialize(ResourceKey bundleKey, ResourceKey key) throws ResourceException

Throws:
  `ResourceException`

### deserialize

ResourceKey deserialize(ResourceKey bundleKey, String serializedKey) throws ResourceKeyCreationException

Throws:
  `ResourceKeyCreationException`